
var RE = {};
var ZHL = {
indent: 0
}
RE.editor = document.getElementsByClassName('ql-editor')[0];

RE.undo = function() {
console.log("undo")
    quill.history.undo();
}

RE.redo = function() {
console.log("redo")
    quill.history.redo();
}

// 设置整体字体大小
RE.setFontSizeWhole = function (fontSize) {
    RE.editor.style.fontSize = fontSize + 'px'
}

/**
 * 设置整体缩进
 * @param {*} type String add:向右 cut:向左
 * @param {*} size Number 移动的距离（px）
 */
RE.setIndentWhole = function (type, size = 4) {
    if (type === 'cut' && ZHL.indent) {
        ZHL.indent -= 10
    }
    if (type === 'add'&& ZHL.indent < document.body.offsetWidth - 50) {
    console.log(ZHL.indent)
        ZHL.indent += 10
    }
    RE.editor.style.paddingLeft = ZHL.indent + 'px'
}

/**
 * 设置整体对齐方式
 * @param {*} val  String center: 居中，left：左对齐，right: 右对齐
 */
RE.setTextAlignWhole = function (val) {
    RE.editor.style.textAlign = val
}


// 设置整体行高
RE.setLineHeightWhole = function (val) {
    RE.editor.style.lineHeight = val
}

// 网页初始化-返回网页的字号、行间距、对齐方式
RE.pageInit = function () {
    const styles = RE.editor.style
    let styledefault = {
    lineHeight: 0,
    textAlign: 'left',
    fontSize: 16
    }
    if (styles.paddingLeft !== '') {
        ZHL.indent = Number(styles.paddingLeft.replace('px', ''))
    }
    Object.keys(styledefault).map(v => {
        if (styles[v] !== '') {
            if (v === 'fontSize') {
                styledefault[v] = styles[v].replace('px', '')
            } else {
            styledefault[v] = styles[v]
            }
        }
    })
    if (document.getElementsByClassName('ql-editor')[0].getElementsByTagName('img').length) {
    var p = document.createElement('p')
            p.innerHTML = '<br /><br /><br />'
            document.getElementsByClassName('ql-editor')[0].appendChild(p)
    }

    zhlEditor.pageInit(JSON.stringify(styledefault))
}

/**
 * @description 设置placeholder
 */
RE.setPlaceholder = function(content) {
//        const text = document.getElementsByClassName ('ql-editor')[0].innerText
//        if (text !== '' && text !== '\n') {
//            document.getElementsByClassName('ql-editor')[0].setAttribute('data-placeholder', '')
//        }else{
//            document.getElementsByClassName('ql-editor')[0].setAttribute('data-placeholder', '开始书写笔记内容')
//        }
         document.getElementsByClassName('ql-editor')[0].setAttribute('data-placeholder', content)
    }

// 导出
RE.export = function () {
try {
   const { lineHeight = '', fontSize = '', paddingLeft = '', textAlign = ''} = document.getElementsByClassName('ql-editor')[0].style
    let style = ''
    if (lineHeight !== '') {
        style += `line-height: ${lineHeight};`
    }
    if (fontSize !== '') {
        style += `font-size: ${fontSize};`
    }
    if (paddingLeft !== '') {
        style += `padding-left: ${paddingLeft};`
    }
    if (textAlign !== '') {
        style += `text-align: ${textAlign};`
    }

    const html = document.getElementsByClassName('ql-editor')[0].innerHTML
    zhlEditor.export( html !== "<p><br></p>" ? `<p class='temp-box' style='${style}'>${html}</p>` : '')
} catch {
    zhlEditor.export('')
}
}


Quill.prototype.getHtml = function() {
    return this.container.querySelector('.ql-editor').innerHTML;
};

// 从原生端打印日志
function sendMessage(name, params = ""){
//    window.webkit.messageHandlers[name].postMessage(params)
}

// 监听文本编辑
quill.on("editor-change", event => {
    console.log(quill.history.stack.undo.length, quill.history.stack.redo.length)
    zhlEditor.onFocusChange(quill.history.stack.undo.length, quill.history.stack.redo.length, quill.hasFocus())
//    window.sendMessage('logger', quill.getFormat())
//    window.sendMessage('actions', quill.getFormat())
});

quill.on("selection-change", event => {
    window.sendMessage('logger', 'selection-change')
    let topPosition = window.getCaretYPosition()
});

// 失去焦点
RE.blur = function() {
    quill.blur()
}

// 获得焦点
function focus() {
    window.sendMessage('logger', "focus")
    quill.focus()
}

// 是否获得焦点
function hasFocus() {
    var focus = quill.hasFocus()
//    window.sendMessage('logger', focus)
}

// 更新
function update() {
    quill.update()
}

// format
function setBold(val) {
    quill.format('bold', val)
}

function setItalic(val) {
    quill.format('italic', val)
}

function setScript(val) {
    quill.format('script', val)
}

function setUnderline(val) {
    quill.format('underline', val)
}

function setStrike(val){
    quill.format('strike', val)
}

function setIndent(val){
    quill.format('indent', val)
}
function setHeader(val) {
    quill.format('header', val);
}

function setSize(val) {
    quill.format('size', val);
}

function setAlign(val) {
    quill.format('align', val);
}

function setBlockquote(val) {
    quill.format('blockquote', val);
}

function setCodeblock(val) {
    quill.format('code-block', val);
}

// ordered & bullet
function setList(val){
    quill.format('list', val)
}

function setLink(val) {
    quill.format('link', val)
}

function setColor(val){
    quill.format('color', val)
}

function setBackgroundColor(val){
    quill.format('background', val)
}

function removeAllFormat() {
    var selection = quill.getSelection()
    quill.removeFormat(0,selection.index)
    
}

RE.insertImage = function(path){
    var selection = quill.getSelection()
    quill.insertEmbed(selection, 'image', path);
    setTimeout(() => {
        imageClick()
      }, 1000)
    selection = quill.getSelection()
    quill.setSelection(selection.index+2,1)

}
function imageClick() {
  var imgs = document.getElementsByTagName('img');
  var l = imgs.length;
  for (var i = 0; i < l; i++) {
    imgs[i].addEventListener('click', function () {
      zhlEditor.imageClick()
    });
  }
}

// 导出
function getHtml() {
    var html = quill.getHtml()
    return html
}

// 导入
RE.insertContent = function(content) {
    const qleditor = quill.container.querySelector('.ql-editor')
    qleditor.innerHTML = content.slice(content.indexOf('>') + 1).slice(0, -4)
    createDom(content, qleditor)
}

function createDom(content, qleditor) {
    const dom = document.createElement("div");
    dom.className = 'temp-dom'
    dom.innerHTML = content
    document.body.appendChild(dom)
    const tempbox = document.getElementsByClassName('temp-box')
    if (tempbox && tempbox.length) {
        const { lineHeight = '', fontSize = '', paddingLeft = '', textAlign } = tempbox[0].style
        if (lineHeight !== '') {
            qleditor.style.lineHeight = lineHeight
        }
        if (fontSize !== '') {
            qleditor.style.fontSize = fontSize
        }
        if (textAlign !== '') {
            qleditor.style.textAlign = textAlign
        }
        if (paddingLeft !== '') {
            qleditor.style.paddingLeft = paddingLeft
            ZHL.indent = Number(paddingLeft.replace('px', ''))
        }
        imageClick()
    }
}
